use coup::*;

mod cli;
use cli::HumanAgent;

fn main() -> CoupResult<()> {
    let mut game = Game::new(2);
    let agents: &[&dyn Agent] = &[&HumanAgent::new(0), &HumanAgent::new(1)];
    while !game.is_game_over() {
        let mut phase = game.action(agents)?;
        while phase != Phase::Done {
            phase = match phase {
                Phase::ActionChallenge(move_) => game.action_challenge(move_, agents)?,
                Phase::Block(move_) => game.block(move_, agents)?,
                Phase::BlockChallenge(move_, block) => game.block_challenge(move_, block, agents)?,
                Phase::Resolution(move_) => game.resolution(move_, agents)?,
                Phase::Done => unreachable!(),
            }
        }
    }
    Ok(())
}
